@enum StageType begin
    STAGE_WEEK=1
    STAGE_MONTH=2
    STAGE_DAY=5
end

# "PSR_STAGETYPE_UNKNOWN" => 0,
# "PSR_STAGETYPE_WEEKLY" => 1,
# "PSR_STAGETYPE_MONTHLY" => 2,
# "PSR_STAGETYPE_QUARTERLY" => 3,
# "PSR_STAGETYPE_HOURLY" => 4,
# "PSR_STAGETYPE_DAILY" => 5,
# "PSR_STAGETYPE_13MONTHLY" => 6,
# "PSR_STAGETYPE_BIMONTHLY" => 7,
# "PSR_STAGETYPE_TRIANNUALLY" => 8,
# "PSR_STAGETYPE_SEMIANNUALLY" => 9,
# "PSR_STAGETYPE_YEARLY" => 10,

@enum BlockDurationMode begin
    FIXED_DURATION
    VARIABLE_DURATION
    HOUR_BLOCK_MAP
end

@enum RelationType begin
    RELATION_1_TO_1
    RELATION_1_TO_N
    RELATION_FROM
    RELATION_TO
    RELATION_TURBINE_TO
    RELATION_SPILL_TO
    RELATION_INFILTRATE_TO
    RELATION_STORED_ENERGY_DONWSTREAM
    RELATION_BACKED
end

"""
    AbstractData
"""
abstract type AbstractData end


"""
    AbstractStudyInterface
"""
abstract type AbstractStudyInterface end

"""
    initialize_study
"""
function initialize_study end

"""
    get_vector
"""
function get_vector end

"""
    max_elements(data::AbstractData, collection::String)

Returns a Int32 with the maximum number of elements for a given `collection`.

Example:
```
max_elements(data, "PSRThermalPlant")
```
"""
function max_elements end

"""
    get_map
"""
function get_map end

"""
    get_map
"""
function get_vector_map end

"""
    get_reverse_map
"""
function get_reverse_map end

"""
    get_reverse_map
"""
function get_reverse_vector_map end

"""
    get_parms
"""
function get_parms end

"""
    get_code(data::AbstractData, collection::String)

Returns a Vector{Int32} containing the code of each element in `collection`.

Example:
```
get_code(data, "PSRThermalPlant")
```
"""
function get_code end

"""
    get_name(data::AbstractData, collection::String)

Returns a Vector{String} containing the name of each element in `collection`.

Example:
```
get_name(data, "PSRThermalPlant")
```
"""
function get_name end

"""
    mapped_vector
"""
function mapped_vector end

"""
    go_to_stage
"""
function go_to_stage end

"""
    go_to_dimension
"""
function go_to_dimension end

"""
    update_vectors!
"""
function update_vectors! end

"""
    description
"""
function description end

"""
    total_stages
"""
function total_stages end

"""
    total_scenarios
"""
function total_scenarios end

"""
    total_blocks
"""
function total_blocks end

"""
    total_openings
"""
function total_openings end

"""
    total_stages_per_year
"""
function total_stages_per_year end

"""
    get_complex_map
"""
function get_complex_map end

"""
    stage_duration
"""
function stage_duration end

"""
    block_duration(data::AbstractData, date::Dates.Date, b::Int)

Returns the duration, in hours, of the block `b` at stage `date`.

    block_duration(data::AbstractData, t::Int, b::Int)

Returns the duration, in hours, of the block `b` at stage `t`.

    block_duration(data::AbstractData, b::Int)

Returns the duration, in hours, of the block `b` at the current stage, set by `go_to_stage`.
"""
function block_duration end

"""
    block_from_stage_hour
"""
function block_from_stage_hour end

"""
    get_nonempty_vector
"""
function get_nonempty_vector end

"""
    MainTypes = Union{Float64, Int32, String, Dates.Date}
"""
const MainTypes = Union{Float64, Int32, String, Dates.Date}

"""
    configuration_parameter
"""
function configuration_parameter end
